local agent_helper = require(AGENT_PATH .. "agent_helper")

AgentAdapter = {
	is_init = false,
	is_login_verify_ing = false,
	login_callback = nil,
	force_logout = false,
	login_verify_url = "cls.mg05.youyannet.com/ah9/login_verify.php",
	pay_verify_url = "cls.mg05.youyannet.com/ah9/pay_callback.php",
	uid = "",
}


-- 初始化
function AgentAdapter:Init()

	if self.is_init then return end
	self.uid = string.gsub((AdapterToLua:getInstance():getDataCache("PRVE_ACCOUNT_NAME") or ""), self:GetSpid() .. "_", "")
	self.is_init = true
	AgentMs:InitLocalPush()
	PlatformBinder:JsonBind("call_agent_logout", function(arg)
		self:LogoutCallback(arg)
		return true
	end)
end

-- 平台ID
function AgentAdapter:GetSpid()
	return "ah9"
end
-- 平台帐号唯一标识
function AgentAdapter:GetOpenId()
	return self.uid
end

-- 加前辍的平台帐号，全平台唯一
function AgentAdapter:GetPlatName()
	return "ah9_" .. self.uid
end


--获得游戏名字
function AgentAdapter:GetGameName()
	return Language.Common.GameName[7] 
end

--获得logo资源名
function AgentAdapter:GetLogoResName()
	return "agentres/big_logo_wyfm.png"
end



function AgentAdapter:Login(callback)

	if self.is_login_verify_ing then
		SysMsgCtrl.Instance:ErrorRemind("正在登录验证中，请稍等...", true)
		return
	end
	self.login_callback = callback
	agent_helper:Login(LUA_CALLBACK(self, self.LoginCallback))--设置登录回调 

end

--按返回键
function AgentAdapter:OnClickBackLogin()
	local callback = function()
		AgentLoginView:OnClickBtnLogin()--重新调出登录界面
    end

	PlatformBinder:JsonCall("call_agent_logout2", "", "", LUA_CALLBACK(self, callback))
end

function AgentAdapter:LoginCallback(result)--登录后回调
	Log("authCode===" .. result)

	local json_obj = cjson.decode(result)
	local username = json_obj.username
	local access_token = json_obj.access_token

	local verify_callback = function(url, arg, data, size)
		
		self.is_login_verify_ing = false
		if size <= 0 then
			return
		end
		
		local ret_t = cjson.decode(data)
		if nil == ret_t or 0 ~= ret_t.ret or nil == ret_t.user then
			return
		end
	
		self.uid = ret_t.user.uid
		LoginController.Instance:SetLoginUserData(self:GetPlatName(), ret_t.user)
		self.login_callback(self:GetPlatName())

		PlatformBinder:JsonCall("call_agent_login_eye", self:GetPlatName(), "", "")--dataeye统计登入

	end

	self.is_login_verify_ing = true
	local now_server_time = math.floor(GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time))
	local real_url = string.format("%s?spid=%s&access_token=%s&username=%s", self.login_verify_url, self:GetSpid(), access_token, username)
	Log("log_real_url==" .. real_url)
	HttpClient:Request(real_url, "", verify_callback)

	return false
	
end

--在浮标切换账号
function AgentAdapter:LogoutCallback(result)--注销回调
	self.uid = ""
	--if not LoginController.Instance:AgentLoginViewIsOpen() then
		ReStart()
	--end
	return true
end

function AgentAdapter:UIEventCallback(event)--UI事件回调
	if "open" == event then
		--self:ShowFloatButton()
	elseif "close" == event then
		--self:ShowFloatButton()
	end
	return true
end

function AgentAdapter:Pay(role_id, role_name, amount, server_id, callback)--购买
	if self.uid == "" then
		SysMsgCtrl.Instance:ErrorRemind("uid为空，请联系客服")
		return
	end


    local orderid = server_id .. "_" .. self.uid .. "_" .. os.time()
	local param_obj = {}
	param_obj.serverId = server_id
	param_obj.Accountname = role_name
	param_obj.cpOrderId = orderid
	param_obj.requestAmount = amount
	param_obj.callbackurl = self.pay_verify_url

	Log("param_obj==" .. cjson.encode(param_obj))
	agent_helper:Pay(cjson.encode(param_obj), nil)
end

--是否支持动态下载
function AgentAdapter:IsDynamicDownloadRes()
	return true
end

--每次升级都发送
function AgentAdapter:SubmitRoleData(role_id, role_name, role_level, zone_id, zone_name)

	local info = {}
	info.serverName = zone_name
	info.serverId = zone_id
	info.Accountname = role_name
	info.level = role_level
	
	PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
end

--每次升级都发送
function AgentAdapter:ReportOnRoleLevUp(role_id, role_name, role_level, zone_id, zone_name)

	local info = {}
	info.serverName = zone_name
	info.serverId = zone_id
	info.Accountname = role_name
	info.level = role_level
	
	PlatformBinder:JsonCall("send_user_info", cjson.encode(info))
end



