require("game/login/login_cfg")
require("game/login/login_loading")
require("game/login/login_recommend")
require("game/login/login_all_serverlist")
require("game/login/login_server_item")

LoginView = LoginView or BaseClass(BaseView)

LOGIN_FONT_SIZE = 35

LOGIN_BG_MOVE_SPEED = 30

LOGIN_SEVER_GROUP = 10

function LoginView:__init()
	self.close_mode = CloseMode.CloseDestroy
	self.zodaer = COMMON_CONSTS.ZORDER_LOGIN

	self.plist_path[1] = "ui/login.png"

	--加载
	self.config_tab[1] = layout_loading
	--服务器列表
	self.config_tab[2] = layout_bg
	self.config_tab[3] = layout_select_sever_list
	self.config_tab[4] = layout_server_recommend
	self.config_tab[5] = layout_all

	self.datasource = nil

	self.server_info = {}
end

function LoginView:__delete()
	if nil ~= self.radio_btn then
		self.radio_btn:DeleteMe()
		self.radio_btn = nil
	end
	self:DeleteServerItemList()
	self:LoadingDelete()
	self.server_info = nil
	if nil ~= self.http then
		self.http:release()
		self.http = nil
	end
	if self.sec_server_list then
		self.sec_server_list:DeleteMe()
	end
end

function LoginView:LoadCallBack()
	self.root_node:setContentSize(cc.size(HandleRenderUnit:GetWidth(), HandleRenderUnit:GetHeight()))
	self:InitView()
	self:RegisterEvents()

	self:SetLoginVisible(false)

	-- 背景音乐
	local audio_res_path = GameResPath.GetAudioBgResPath(AudioBg.LoginView)
	AudioManager.Instance:PlayMusic(audio_res_path)
end

function LoginView:InitView()
	self:InitLoginView()
	--loading
	self:InitLoadingView()
	--选服
	self:InitRecommendView()
	self:InitAllListView()
end

function LoginView:RegisterEvents()
	self.node_tree.layout_bg.layout_return.node:setTouchEnabled(true)
	self.node_tree.layout_bg.layout_enter_game.node:setTouchEnabled(true)
	CCUI.AddClickEventListener(self.node_tree.layout_bg.layout_return.node, BindTool.Bind1(self.OnLoginBack, self), nil, true)
	CCUI.AddClickEventListener(self.node_tree.layout_bg.layout_enter_game.node, BindTool.Bind1(self.OnLoginConfirm, self), nil, true)
end

function LoginView:InitLoginView()
	local screen_w = HandleRenderUnit:GetWidth()
	local screen_h = HandleRenderUnit:GetHeight()

	self.node_tree.layout_bg.node:setPosition(screen_w / 2, screen_h / 2)
	self.node_tree.layout_select_sever_list.node:setPosition(screen_w / 2 - 383, screen_h / 2 + 23)
	self.node_tree.layout_server_recommend.node:setPosition(screen_w / 2 + 134, screen_h / 2 + 23)
	self.node_tree.layout_all.node:setPosition(screen_w / 2 + 134, screen_h / 2 + 23)

	--创建背景
	local bg_path = "ui/login/login_bg.jpg"

	local agent_id = GLOBAL_CONFIG.package_info.config.agent_id or "dev"
	local agent_login = GLOBAL_CONFIG.login[agent_id]
	
	if nil ~= agent_login and nil ~= agent_login.login_bg_path then
		bg_path = agent_login.login_bg_path
	end

	self.bg1 = CCUI.CreateImageView(screen_w / 2, screen_h / 2, bg_path, false)
	local size = self.bg1:getContentSize()
	self.root_node:addChild(self.bg1, 0, 0)


	--self.bg2 = CCUI.CreateImageView(screen_w / 2 + size.width, screen_h / 2, bg_path, false)
	--self.root_node:addChild(self.bg2, 0, 0)
	--self:BeginBgMove(self.bg1, self.bg2)


	self:CreateDecoration()
end

function LoginView:CreateDecoration()
	local screen_w = HandleRenderUnit:GetWidth()
	local screen_h = HandleRenderUnit:GetHeight()
	local clouds_cfg = {{res_id = 22, x = 0, y = 60},
						{res_id = 22, x = 0, y = 70},
						{res_id = 22, x = 0, y = 120},
						{res_id = 22, x = 0, y = 60},
						{res_id = 22, x = 0, y = 130},
						{res_id = 22, x = 0, y = 70},
						{res_id = 22, x = 0, y = 120},
						{res_id = 22, x = 0, y = 30},
						}

	for k,v in pairs(clouds_cfg) do
		local anim_path = GameResPath.GetDecorationAnimPath(v.res_id)
		local anim_name = GameResPath.GetDecorationAnimName(v.res_id)
		local cloud = RenderUnit.CreateAnimSprite(anim_path, anim_name, 0.15, 20)
		self.root_node:addChild(cloud)
		cloud:setPosition(v.x + screen_w / #clouds_cfg * k, v.y)
	end

	--stand he
	-- local stand_he_cfg = {--{res_id = 3, x = 1042, y = 337, scale = 0.7},
	-- 					  {res_id = 3, x = 1250, y = 280, scale = 1},}

	-- for k,v in pairs(stand_he_cfg) do
	-- 	for i = 1, 2 do 
	-- 		local anim_path = GameResPath.GetDecorationAnimPath(v.res_id)
	-- 		local anim_name = GameResPath.GetDecorationAnimName(v.res_id)
	-- 		local stand_he = RenderUnit.CreateAnimSprite(anim_path, anim_name, 0.15, 20)
	-- 		stand_he:setPosition(v.x, v.y)
	-- 		stand_he:setScale(v.scale)
	-- 		if 1 == i then self.bg1:addChild(stand_he) end
	-- 		if 2 == i then self.bg2:addChild(stand_he) end
	-- 	end
	-- end

	-- --move he
	-- local move_he_config = {{res_id = 27, x = screen_w - 140, y = screen_h - 200},
	-- 						{res_id = 27, x = screen_w - 120, y = screen_h - 230},
	-- 						{res_id = 27, x = screen_w - 100, y = screen_h - 270}}

	-- for k,v in pairs(move_he_config) do
	-- 	local anim_path = GameResPath.GetDecorationAnimPath(v.res_id)
	-- 	anim_name = GameResPath.GetDecorationAnimName(v.res_id)
	-- 	local move_he = RenderUnit.CreateAnimSprite(anim_path, anim_name, 0.15, 20)
	-- 	self.root_node:addChild(move_he, 0, 0)
	-- 	move_he:setPosition(v.x, v.y)
	-- 	move_he:setFlippedX(true)
	-- 	local act = CCActionEdit.Instance:CreateCCAction("xianhe_login_move", v.x, v.y, -(screen_w + 100)) 
	-- 	move_he:runAction(act)	
	-- end	
end

-- --开始移动背景 
-- function LoginView:BeginBgMove(bg1,bg2)
-- 	if nil == bg1 or nil == bg2 then return end
-- 	function move_fun(bg, time)
-- 		if nil == bg or nil == time then return end
-- 		local size = bg:getContentSize()
-- 		local move_by = cc.MoveBy:create(time, cc.p(-size.width, 0))
-- 		function func()
-- 			local x = bg:getPositionX()
-- 			if x < 0 then --是否需要重设位置
-- 				bg:setPosition(cc.p(HandleRenderUnit:GetWidth()/2 + size.width, HandleRenderUnit:GetHeight()/2))
-- 			end
-- 			move_fun(bg, LOGIN_BG_MOVE_SPEED)
-- 		end
-- 		local call_back = cc.CallFunc:create(func)
-- 		local sequence = cc.Sequence:create(move_by, call_back)
-- 		bg:stopAllActions()
-- 		bg:runAction(sequence)
-- 	end
-- 	move_fun(bg1, LOGIN_BG_MOVE_SPEED)
-- 	move_fun(bg2, LOGIN_BG_MOVE_SPEED)
-- end

-- 重连
function LoginView:Reconnect()
	self:SetChooseServerVisible(false)
	self.node_tree.layout_loading.node:setVisible(true)

	self:OnLoginPlatSucc()

	self:UpdateLoading(0)
end

-- 显示/隐藏选服界面
function LoginView:SetChooseServerVisible(is_visible)
	self.node_tree.layout_bg.node:setVisible(is_visible)
	self.node_tree.layout_select_sever_list.node:setVisible(is_visible)
	self.node_tree.layout_server_recommend.node:setVisible(is_visible)
	self.node_tree.layout_all.node:setVisible(is_visible)
end

-- 登录平台成功
function LoginView:OnLoginPlatSucc()
	self:LoadServerList()
end

function LoginView:LoadServerList()
	if not self:IsLoaded() then
		return
	end
	Log("Login::LoadServerList ")

	local recommend_server = GLOBAL_CONFIG.server_info.last_server or 1  --推荐服，名字不改了

	local local_last_server = PlatformAdapter:GetShareValueByKey(AgentAdapter:GetPlatName() .. "last_login_server")
	if local_last_server == nil or local_last_server == "" then
		self.server_info.last_server = recommend_server
	else	
		self.server_info.last_server = tonumber(local_last_server) or 1
	end
	self.server_info.server_list = {}
	self.server_info.recommend_server = recommend_server

	local server_offset = GLOBAL_CONFIG.server_info.server_offset or 0 --偏移id
	if server_offset >= 1500 then
		server_offset = 0
	end

	local plat_account_type = GameVoManager.Instance:GetUserVo().plat_account_type
	for _, v in ipairs(GLOBAL_CONFIG.server_info.server_list) do
		if PLAT_ACCOUNT_TYPE_TEST == plat_account_type or 4 ~= v.flag and v.id > server_offset then	-- 非测试号屏蔽测试服
			self.server_info.server_list[v.id] = v
		end
	end

	local last_login_server = self.server_info.last_server

	if LoginController.Instance:GetIsReConnectIng() then 
		local server_id = AdapterToLua:getInstance():getDataCache("PRVE_SRVER_ID")
		if server_id == "" then server_id = last_login_server end
		server_id = tonumber(server_id)

		local last_login_server_data = self.server_info.server_list[server_id] --上次登陆的服务器
		-- 跨服
		local cs_info_str = AdapterToLua:getInstance():getDataCache("CROSS_SERVER_INFO")
		-- AdapterToLua:getInstance():setDataCache("CROSS_SERVER_INFO", "")

		if nil ~= cs_info_str and "" ~= cs_info_str then
			local list = Split(cs_info_str, "##")
			local cs_server_data = {}

		    cs_server_data.id = list[1]						-- 服务器ID
            cs_server_data.name = list[2]					-- 服务器名字
            cs_server_data.ip = list[3]						-- 登录服务器IP
            cs_server_data.port = list[4]					-- 登录服务器端口
            cs_server_data.open_time = list[5]				-- 服务器开服时间
            cs_server_data.ahead_time = list[6]       	 	-- 提前开放登录时间(秒)
            cs_server_data.pause_time = list[7]        		-- 维护结束时间
            cs_server_data.flag = list[8]					-- 服务器标记 (1: 火爆 2: 新服 3: 即将开服 4: 测试 5: 维护)
            cs_server_data.avatar = list[9]					-- 头像ID (未实现)
            cs_server_data.role_name = list[10]				-- 角色名字 (未实现)
            cs_server_data.role_level = list[11]			-- 角色等级 (未实现)
            last_login_server_data = cs_server_data
		end
		if last_login_server_data == nil then  -- 重连失败
			LoginController.Instance:ReconnectFail()
		else   --重连成功
			self:DoLogin(last_login_server_data.ip, last_login_server_data.port)
		end
	else
		MainProber:Step(MainProber.STEP_SERVER_SHOW_LIST)
		self:SetLoginVisible(true)
		if nil == self.sec_server_list then
			local ph_sec_server_list = self.node_t_list.ph_selectsever_list
			self.sec_server_list = UiListView.New()
			self.sec_server_list:CreateView({width = 300, height = ph_sec_server_list.param.h, direction=1, itemRender = LoginSelectServersItem})
			self.sec_server_list:GetView():setAnchorPoint(0, 0)
			self.node_tree.layout_select_sever_list.node:addChild(self.sec_server_list:GetView(), 300, 300)
			self.sec_server_list:GetView():setPosition(ph_sec_server_list.param.x, ph_sec_server_list.param.y)
			self.sec_server_list:SetSelectCallBack(BindTool.Bind1(self.SelectServerCallback, self))
			self.sec_server_list:SetData(self:GetSecSeverListData())
		end
		self.sec_server_list:SelectIndex(1)
	end
end

function LoginView:GetSecSeverListData(index)
	if nil == self.server_data_list then
		self.server_data_list = {}
		local data = self.server_data_list
		data[1] = 0 --推荐组
		data[2] = {}
		--1.根据server_id排序
		local show_list = {}
		for k,v in pairs(self.server_info.server_list) do
		   	show_list[#show_list + 1] = v
		end
		table.sort(show_list, SortTools.KeyUpperSorter("id"))
		--2.把大于等于2000的体验服保存起来
		local test_server_list = {}
		for i,v in ipairs(show_list) do
			if v.id >= 2000 then
				table.insert(test_server_list, v)
			end
		end
		--3.把大于等于2000的体验服移除
		for i = 1, #test_server_list do
			table.remove(show_list, 1)
		end
		--4.特殊分组，开服个数取余数，作为第一组服务器个数
		local group = 2
		local sc_num = #show_list%LOGIN_SEVER_GROUP
		if sc_num > 0 then
			group = 3
			for i=1,sc_num do
				local vo = 	data[2]
				vo[#vo + 1] = show_list[1]
				table.remove(show_list, 1)
			end
		end
		--5.正常分组每LOGIN_SEVER_GROUP个服为一组
		for i,v in ipairs(show_list) do
			if data[group] and #data[group] >= LOGIN_SEVER_GROUP then 
				group = group + 1
			end 
			data[group] = data[group] or {}
			local vo = 	data[group]
			vo[#vo + 1] = v
		end
		--若有体验服，则把体验服放到最后
		if #test_server_list > 0 then
			self.server_data_list[#self.server_data_list + 1] = test_server_list
		end
	end  

	return index and self.server_data_list[index] or self.server_data_list
end

function LoginView:SelectServerCallback(server)
	if server.item_index and server.item_index > 0 then
		self:SelectTabCallback(server.item_index)
	end
end

function LoginView:SelectTabCallback(index)
	if 1 == index then
		self.recommend.node:setVisible(true)
		self.alllist.node:setVisible(false)
		self:OnFlushRecommond(self.server_info)
	else
		self.recommend.node:setVisible(false)
		self.alllist.node:setVisible(true)
		self:OnFlushAll(self:GetSecSeverListData(index))
	end
end

--点击确认按钮
function LoginView:OnLoginConfirm()
	if self.datasource == nil then return end

	local user_vo = GameVoManager.Instance:GetUserVo()
	if not user_vo.plat_is_verify then
		return
	end

	local now_server_time = GLOBAL_CONFIG.server_info.server_time + (Status.NowTime - GLOBAL_CONFIG.client_time)
	if PLAT_ACCOUNT_TYPE_COMMON == user_vo.plat_account_type and 
		nil ~= self.datasource.open_time and nil ~= self.datasource.ahead_time and
		 now_server_time < self.datasource.open_time - self.datasource.ahead_time then
		SysMsgCtrl.Instance:ErrorRemind(Language.Login.ServerOpenTips2, true)
		return
	end

	if PLAT_ACCOUNT_TYPE_COMMON == user_vo.plat_account_type and 
		nil ~= self.datasource.pause_time and 0 < self.datasource.pause_time and
		now_server_time < self.datasource.pause_time then
		SysMsgCtrl.Instance:ErrorRemind(Language.Login.ServerOpenTips3, true)
		return
	end
	
	local text_ip = self.datasource.ip
	local text_port = self.datasource.port

	user_vo.plat_server_id = self.datasource.id
	user_vo.real_server_id = user_vo.plat_server_id
	user_vo.plat_server_name = self.datasource.name
	AdapterToLua:getInstance():setDataCache("PRVE_SRVER_ID", self.datasource.id)

	MainProber:Step(MainProber.STEP_CLICK_CONFIRM_LOGIN or 230, user_vo.plat_name, self.datasource.id, text_ip, text_port)

	self:DoLogin(text_ip, text_port)
	Log("Login::OnLoginConfirm ip:" .. tostring(text_ip) .. " , port:" .. tostring(text_port) .. ", name:" .. tostring(user_vo.plat_name) .. ", server_id:" ..tostring(self.datasource.id))
end

function LoginView:DoLogin(text_ip, text_port)
	if nil == text_ip or string.len(text_ip) <= 0 then
		return
	end

	if nil == text_port or string.len(text_port) <= 0 then
		return
	end

	local game_net = GameNet.Instance

	if game_net:IsLoginServerConnected() or game_net:IsLoginServerInAsyncConnect()
		or game_net:IsGameServerConnected() or game_net:IsGameServerInAsyncConnect() then
		if game_net:IsLoginServerConnected() and GLOBAL_CONFIG.param_list.switch_list.active_code then
			LoginActCodePop.Instance:SetOkFun(BindTool.Bind1(LoginController.Instance.DoNewRoleCreateHandler, LoginController.Instance))
		end
		return
	end

	local user_vo = GameVoManager.Instance:GetUserVo()
	MainProber:Step(MainProber.STEP_SERVER_LOGIN_BEG, user_vo.plat_name, user_vo.plat_server_id, text_ip, text_port)
	if MainProber.Step2 then
		MainProber.server_id = user_vo.plat_server_id
		MainProber:Step2(800, MainProber.user_id, MainProber.server_id) 
	end

	game_net:SetLoginServerInfo(text_ip, text_port)
	LoginController.Instance:ResetConnectCount()
	LoginController.Instance:ShowConnectingEffect()
	game_net:AsyncConnectLoginServer(5)
end

--点击返回按钮
function LoginView:OnLoginBack()
	local login_state = LoginController.Instance:GetLoginState()
	if login_state == LOGIN_STATE_CREATE_ROLE or login_state == LOGIN_STATE_LOADING then
		return
	end

	LoginController.Instance:RemoveConnectingEffect()
	self:SetLoginVisible(false)
	self:DeleteServerItemList()
	self.scroll_server_list:removeAllChildren()
	self.data = nil

	if nil ~= self.last_server_item then
		self.last_server_item.toggle:removeFromParent(true)
	end
	self.last_server_item = nil

	if nil ~= self.recommend_item then
		self.recommend_item.toggle:removeFromParent(true)
	end
	self.recommend_item = nil

	GameNet.Instance:DisconnectLoginServer()

	if AgentAdapter.OnClickBackLogin then
		AgentAdapter:OnClickBackLogin()
	end
end

function LoginView:CloseCallBack()
	LoginController.Instance:AgentLoginViewClose(false)
end

function LoginView:SetLoginVisible(is_show)
	if is_show then
		LoginController.Instance:AgentLoginViewClose(true)
	else
		LoginController.Instance:AgentLoginViewOpen(true)
	end

	self:SetChooseServerVisible(is_show)
	self.node_tree.layout_loading.node:setVisible(false)
end

function LoginView:GetIsInSelectServerView()
	if nil == self.node_tree.layout_select_sever_list.node then
		return false
	end
	return self.node_tree.layout_select_sever_list.node:isVisible()
end

function LoginView:CreateAnimDisplay(parent, stage, scale, prof)
	if nil == parent or nil == stage or nil == scale then
		return
	end

	local display = RoleDisplay.New(parent, 999, false, true, true)
	local x, y = stage:getPosition()
	display:SetPosition(x, y + 30)
	display:SetScale(scale)
	display:SetRoleResId(prof)

	return display
end
